/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/

#include	"config.h"
#include	"STC8A_Exti.h"
#include	"STC8A_GPIO.h"
#include	"STC8A_UART.h"
#include	"STC8A_NVIC.h"
#include	"STC8A_Delay.h"

/*************	˵	**************

ʾINT0~INT4 5ԴMCU߻.

ӴԴѴ115200,N,8,1.

ʱ, ѡʱ 22.1184MHz (û"config.h"޸Ƶ).

******************************************/

/*************	س	**************/


/*************	ر	**************/
u8 WakeUpSource;
u8 WakeUpCnt;

/*************	غ	**************/



/*************  ⲿͱ *****************/



/******************** IO ********************/
void	GPIO_config(void)
{
	GPIO_InitTypeDef	GPIO_InitStructure;				//ṹ

	GPIO_InitStructure.Pin  = GPIO_Pin_All;			//ָҪʼIO, GPIO_Pin_0 ~ GPIO_Pin_7, 
	GPIO_InitStructure.Mode = GPIO_PullUp;			//ָIOʽ,GPIO_PullUp,GPIO_HighZ,GPIO_OUT_OD,GPIO_OUT_PP
	GPIO_Inilize(GPIO_P3,&GPIO_InitStructure);	//ʼ
}

/******************** INT ********************/
void	Exti_config(void)
{
	EXTI_InitTypeDef	Exti_InitStructure;							//ṹ

	Exti_InitStructure.EXTI_Mode      = EXT_MODE_Fall;//жģʽ,   EXT_MODE_RiseFall,EXT_MODE_Fall
	Ext_Inilize(EXT_INT0,&Exti_InitStructure);				//ʼ
	NVIC_INT0_Init(ENABLE,Priority_0);		//жʹ, ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3

	Exti_InitStructure.EXTI_Mode      = EXT_MODE_Fall;//жģʽ,   EXT_MODE_RiseFall,EXT_MODE_Fall
	Ext_Inilize(EXT_INT1,&Exti_InitStructure);				//ʼ
	NVIC_INT1_Init(ENABLE,Priority_0);		//жʹ, ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3

	NVIC_INT2_Init(ENABLE,NULL);		//жʹ, ENABLE/DISABLE; ȼ
	NVIC_INT3_Init(ENABLE,NULL);		//жʹ, ENABLE/DISABLE; ȼ
	NVIC_INT4_Init(ENABLE,NULL);		//жʹ, ENABLE/DISABLE; ȼ
}

/****************  ڳʼ *****************/
void	UART_config(void)
{
	COMx_InitDefine		COMx_InitStructure;					//ṹ
	COMx_InitStructure.UART_Mode      = UART_8bit_BRTx;		//ģʽ,   UART_ShiftRight,UART_8bit_BRTx,UART_9bit,UART_9bit_BRTx
	COMx_InitStructure.UART_BRT_Use   = BRT_Timer1;			//ʹò, BRT_Timer1, BRT_Timer2 (ע: 2̶ʹBRT_Timer2)
	COMx_InitStructure.UART_BaudRate  = 115200ul;			//,     110 ~ 115200
	COMx_InitStructure.UART_RxEnable  = ENABLE;				//,   ENABLEDISABLE
	UART_Configuration(UART1, &COMx_InitStructure);		//ʼ USART1,USART2,USART3,USART4
	NVIC_UART1_Init(ENABLE,Priority_1);		//жʹ, ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3
}

/******************** ***********************/
void main(void)
{
	GPIO_config();
	UART_config();
	EA  = 1;		//Enable all interrupt

	printf("STC8 EXINT Wakeup Test Programme!\r\n");	//UARTһַ
	
	while(1)
	{
		while(!INT0);	//ȴжΪߵƽ
		while(!INT1);	//ȴжΪߵƽ
		while(!INT2);	//ȴжΪߵƽ
		while(!INT3);	//ȴжΪߵƽ
		while(!INT4);	//ȴжΪߵƽ
		delay_ms(10);	//delay 10ms

		while(!INT0);	//ȴжΪߵƽ
		while(!INT1);	//ȴжΪߵƽ
		while(!INT2);	//ȴжΪߵƽ
		while(!INT3);	//ȴжΪߵƽ
		while(!INT4);	//ȴжΪߵƽ
		delay_ms(10);	//delay 10ms

		Exti_config();
		WakeUpSource = 0;

		PCON |= 2;		//Sleep
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		
		if(WakeUpSource == 1)	printf("жINT0  ");
		if(WakeUpSource == 2)	printf("жINT1  ");
		if(WakeUpSource == 3)	printf("жINT2  ");
		if(WakeUpSource == 4)	printf("жINT3  ");
		if(WakeUpSource == 5)	printf("жINT4  ");
		WakeUpSource = 0;
		
		WakeUpCnt++;
		TX1_write2buff(WakeUpCnt/100+'0');
		TX1_write2buff(WakeUpCnt%100/10+'0');
		TX1_write2buff(WakeUpCnt%10+'0');
		PrintString1("λ\r\n");
	}

}

